#!/usr/bin/perl
#
# Copyright(C) 2001 TOSHIBA CORPORATION, All Rights Reserved.
#
# --- $Revision: 1.35 $
# --- $Date: 2001/06/07 11:53:51 $
#

# --- dirs ---
# --- proc dir ---
$tsap_proc_dir="/proc/sys/net/wireless/";

# --- file dir ---
$tsap_file_dir="/etc/sysconfig/tsb/";
$tsap_config="tsb_ap_config";

# --- proc ---
# --- proc articles ---
$tsap_proc_art{"1"} = "station_name";
$tsap_proc_art{"2"} = "network_name";
$tsap_proc_art{"3"} = "channel";
$tsap_proc_art{"4"} = "channel_list";
$tsap_proc_art{"5"} = "reject_any";
$tsap_proc_art{"6"} = "distance_between_aps";
$tsap_proc_art{"7"} = "dtim_period";
$tsap_proc_art{"8"} = "card_profile";
#
$tsap_proc_art{"9"} = "multicast_rate";
$tsap_proc_art{"10"} = "keys";
#
$tsap_proc_art{"10"}->{"switch"} = "enable_encryption";
$tsap_proc_art{"10"}->{"id"} = "transmit_key_id";
$tsap_proc_art{"10"}->{"1"} = "key1";
$tsap_proc_art{"10"}->{"2"} = "key2";
$tsap_proc_art{"10"}->{"3"} = "key3";
$tsap_proc_art{"10"}->{"4"} = "key4";
#
$tsap_proc_art{"20"} = "mac_accept";
$tsap_proc_art{"21"} = "enable_macfilter";
$tsap_proc_art{"22"} = "mac_accept"; # mac_accept_count
$tsap_proc_art{"23"} = "mac_accept"; # mac_accept_add
$tsap_proc_art{"24"} = "mac_accept"; # mac_accept_del
$tsap_proc_art{"25"} = "mac_accept"; # mac_accept_allclear
$tsap_proc_art{"26"} = "mac_rejected";
$tsap_proc_art{"27"} = "mac_rejected"; # mac_rejected_count
$tsap_proc_art{"28"} = "mac_rejected"; # mac_rejected_del
$tsap_proc_art{"29"} = "mac_rejected"; # mac_rejected_allclear

# --- proc_keys ---
# --- proc_write ---
@tsap_proc_writes = ( 1, 2, 3, 5, 6, 7, 9, 10, 21);
@tsap_proc_writes_lists = ( 20, 26);
@tsap_proc_writes_sublists = ( 10);
foreach(@tsap_proc_writes) {
    $tsap_proc_write{$tsap_proc_art{$_}} = $tsap_proc_dir.$tsap_proc_art{$_};
}
foreach(@tsap_proc_writes_lists) {
    $tsap_proc_write{$tsap_proc_art{$_}} = $tsap_proc_dir.$tsap_proc_art{$_};
    $tsap_proc_write_lists{$tsap_proc_art{$_}} = $_;
}
#$tsap_proc_write{"enable_encryption"} = $tsap_proc_dir."enable_encryption";
foreach $i (@tsap_proc_writes_sublists) {
    foreach(values(%{$tsap_proc_art{$i}})) {
	$tsap_proc_write{$_} = $tsap_proc_dir.$_;
    }
}

# --- proc_read ---
@tsap_proc_reads = ( 4, 8, 10, 26);
foreach(@tsap_proc_reads) {
    $tsap_proc_read{$tsap_proc_art{$_}} = $tsap_proc_dir.$tsap_proc_art{$_};
}

# --- proc files ---
@tsap_proc_files = ( 1, 2, 3, 5, 6, 7, 9, 10, 21);
@tsap_proc_files_lists = ( 20);
$tsap_file_proc = $tsap_file_dir."tsb_ap_proc/";
foreach(@tsap_proc_files) {
    $tsap_proc_file{$tsap_proc_art{$_}} = $tsap_file_proc.$tsap_proc_art{$_};
}
foreach(@tsap_proc_files_lists) {
    $tsap_proc_file{$tsap_proc_art{$_}} = $tsap_file_proc.$tsap_proc_art{$_};
    $tsap_proc_file_lists{$tsap_proc_art{$_}} = $_;
}
# --- http ---
# --- http articles ---
#
$tsap_http_dir = $tsap_file_dir."tsb_ap_http/";
@tsap_http_lists = (1,2,3,4,5,6,7,8,9);
$tsap_http_art{"1"} = "tsb_http_mode";
$tsap_http_art{"2"} = $tsap_proc_art{"4"};
$tsap_http_art{"3"} = $tsap_proc_art{"8"};
$tsap_http_art{"4"} = $tsap_proc_art{"10"}->{"switch"};
$tsap_http_art{"5"} = $tsap_proc_art{"10"}->{"id"};
$tsap_http_art{"6"} = "chk_".$tsap_proc_art{"10"}->{"1"};
$tsap_http_art{"7"} = "chk_".$tsap_proc_art{"10"}->{"2"};
$tsap_http_art{"8"} = "chk_".$tsap_proc_art{"10"}->{"3"};
$tsap_http_art{"9"} = "chk_".$tsap_proc_art{"10"}->{"4"};
foreach(@tsap_http_lists) {
    $tsap_http_file{$tsap_http_art{$_}} = $tsap_http_dir.$tsap_http_art{$_};
}

# --- bridge ---
$tsb_bridge="/etc/rc.d/init.d/tsb_bridge";
$tsb_bridge_conf="tsb_bridge.conf";
$tsb_bridge_lans = "lan_devs";
$tsb_bridge_dev = "tsap_dev";
$tsap_http_file{$tsb_bridge_conf} = $tsap_file_dir.$tsb_bridge_conf;
$tsap_http_file{$tsb_bridge_lans} = $tsap_http_dir.$tsb_bridge_lans;
$tsap_http_file{$tsb_bridge_dev} = $tsap_http_dir.$tsb_bridge_dev;

# --- snmp ---
$tsap_snmp = "/etc/rc.d/init.d/snmpd";
$tsap_snmp_tsap = ".1.3.6.1.4.1.186.22.1.11.1";
$tsb_snmp_dir="/etc/snmp/";
$tsb_snmp_conf="snmpd.conf";
$tsap_proc_file{$tsb_snmp_conf} = $tsb_snmp_dir.$tsb_snmp_conf;
$tsap_proc_file_lists{$tsb_snmp_conf} = $tsb_snmp_conf;

# --- command ---
$tsap_ap_com_pi = "proc_init";
$tsap_ap_com_pr = "proc_read";
$tsap_ap_com_pw = "proc_write";
$tsap_ap_com_fr = "file_read";
$tsap_ap_com_fw = "file_write";
$tsap_ap_com_fa = "file_add";
$tsap_http_com_fr = "http_read";
$tsap_http_com_fw = "http_write";

# --- function ---
sub tsb_read {
    my($argv);
    my(@result);
    $argv = @_[0];
    open(PR, $argv) or die "";
	while (<PR>) {
	    chomp;
	    push @result, $_;
	}
    close(PR);
    return @result;
}
